<?php

/**
 * @author Jaap Jansma (CiviCooP) <jaap.jansma@civicoop.org>
 * @license http://www.gnu.org/licenses/agpl-3.0.html
 */

 namespace Civi\FormProcessor\Type;

 use \Civi\FormProcessor\Type\AbstractType;
 use \Civi\FormProcessor\Type\OptionListInterface;

 class MembershipTypeType extends AbstractType implements OptionListInterface {

   protected $options;

  public function validateValue($value, $allValues=array()) {
    if (\CRM_Utils_Type::validate($value, 'Integer', false) === NULL) {
      return false;
    }

    $membershipTypes = $this->getOptions(array());
    if (!isset($membershipTypes[$value])) {
      return false;
    }

    return true;
  }

  /**
   * Returns the type number from CRM_Utils_Type
   */
  public function getCrmType() {
    return \CRM_Utils_Type::T_INT;
  }

  public function getOptions($params) {
    if (!$this->options) {
      $this->options = array();
      $membershipTypeApi = civicrm_api3('MembershipType', 'get', array('is_active' => 1, 'options' => array('limit' => 0)));
      foreach($membershipTypeApi['values'] as $membershipType) {
        $this->options[$membershipType['id']] = $membershipType['name'];
      }
    }
    return $this->options;
  }

   /**
    * Sets the default values of this action
    */
   public function setDefaults() {
     parent::setDefaults();
     $this->options = null;
   }

 }
