<?php

use CRM_FormProcessor_ExtensionUtil as E;

/**
 * FormProcessorAction.Validatename API
 *
 * @param array $params
 * @return array API result descriptor
 * @see civicrm_api3_create_success
 * @see civicrm_api3_create_error
 * @throws API_Exception
 */
function civicrm_api3_form_processor_action_validatename($params) {
	$name = $params['name'];
  $form_processor_instance_id = $params['form_processor_instance_id'];
	$id = isset($params['id']) ? $params['id'] : null;
  $returnValues['name'] = $name;
  $returnValues['is_valid'] = CRM_FormProcessor_BAO_FormProcessorAction::isNameValid($name, $form_processor_instance_id, $id);
  return $returnValues;
}

/**
 * FormProcessorAction.Validatename API specification (optional)
 * This is used for documentation and validation.
 *
 * @param array $spec description of fields supported by this API call
 * @return void
 * @see http://wiki.civicrm.org/confluence/display/CRM/API+Architecture+Standards
 */
function _civicrm_api3_form_processor_action_validatename_spec(&$spec) {
	$spec['id'] = array(
		'title' => E::ts('ID'),
		'type' => CRM_Utils_Type::T_INT,
		'api.required' => false
	);
	$spec['name'] = array(
		'title' => E::ts('Name'),
		'type' => CRM_Utils_Type::T_STRING,
		'api.required' => true
	);
  $spec['form_processor_instance_id'] = array(
    'title' => E::ts('Form Processor ID'),
    'type' => CRM_Utils_Type::T_INT,
    'api.required' => true
  );
}